Index: /trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp
===================================================================
--- /trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 81319)
+++ /trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 81320)
@@ -31,9 +31,8 @@
 
 
-static int sharedClipboardTransferThreadCreate(PSHCLTRANSFER pTransfer, PFNRTTHREAD pfnThreadFunc, void *pvUser);
-static int sharedClipboardTransferThreadDestroy(PSHCLTRANSFER pTransfer, RTMSINTERVAL uTimeoutMs);
-static PSHCLTRANSFER sharedClipboardTransferCtxGetTransferInternal(PSHCLTRANSFERCTX pTransferCtx, uint32_t uIdx);
-static int sharedClipboardConvertFileCreateFlags(bool fWritable, unsigned fShClFlags, RTFMODE fMode,
-                                                 SHCLOBJHANDLE handleInitial, uint64_t *pfOpen);
+static int shClTransferThreadCreate(PSHCLTRANSFER pTransfer, PFNRTTHREAD pfnThreadFunc, void *pvUser);
+static int shClTransferThreadDestroy(PSHCLTRANSFER pTransfer, RTMSINTERVAL uTimeoutMs);
+static PSHCLTRANSFER shClTransferCtxGetTransferInternal(PSHCLTRANSFERCTX pTransferCtx, uint32_t uIdx);
+static int shClConvertFileCreateFlags(bool fWritable, unsigned fShClFlags, RTFMODE fMode, SHCLOBJHANDLE handleInitial, uint64_t *pfOpen);
 
 /** @todo Split this file up in different modules. */
@@ -762,6 +761,5 @@
  * @param   hObj                Object handle of the object to get handle info for.
  */
-inline PSHCLOBJHANDLEINFO sharedClipboardTransferObjectGet(PSHCLTRANSFER pTransfer,
-                                                           SHCLOBJHANDLE hObj)
+inline PSHCLOBJHANDLEINFO shClTransferObjGet(PSHCLTRANSFER pTransfer, SHCLOBJHANDLE hObj)
 {
     PSHCLOBJHANDLEINFO pIt;
@@ -809,7 +807,7 @@
 
                 uint64_t fOpen;
-                rc = sharedClipboardConvertFileCreateFlags(fWritable,
-                                                           pOpenCreateParms->fCreate, pOpenCreateParms->ObjInfo.Attr.fMode,
-                                                           SHCLOBJHANDLE_INVALID, &fOpen);
+                rc = shClConvertFileCreateFlags(fWritable,
+                                                pOpenCreateParms->fCreate, pOpenCreateParms->ObjInfo.Attr.fMode,
+                                                SHCLOBJHANDLE_INVALID, &fOpen);
                 if (RT_SUCCESS(rc))
                 {
@@ -877,5 +875,5 @@
     if (pTransfer->State.enmSource == SHCLSOURCE_LOCAL)
     {
-        PSHCLOBJHANDLEINFO pInfo = sharedClipboardTransferObjectGet(pTransfer, hObj);
+        PSHCLOBJHANDLEINFO pInfo = shClTransferObjGet(pTransfer, hObj);
         if (pInfo)
         {
@@ -962,5 +960,5 @@
     if (pTransfer->State.enmSource == SHCLSOURCE_LOCAL)
     {
-        PSHCLOBJHANDLEINFO pInfo = sharedClipboardTransferObjectGet(pTransfer, hObj);
+        PSHCLOBJHANDLEINFO pInfo = shClTransferObjGet(pTransfer, hObj);
         if (pInfo)
         {
@@ -1024,5 +1022,5 @@
     if (pTransfer->State.enmSource == SHCLSOURCE_LOCAL)
     {
-        PSHCLOBJHANDLEINFO pInfo = sharedClipboardTransferObjectGet(pTransfer, hObj);
+        PSHCLOBJHANDLEINFO pInfo = shClTransferObjGet(pTransfer, hObj);
         if (pInfo)
         {
@@ -1129,5 +1127,5 @@
  * @returns VBox status code.
  * @param   ppTransfer          Where to return the created Shared Clipboard transfer struct.
- *                              Must be destroyed by SharedClipboardTransferDestroy().
+ *                              Must be destroyed by ShClTransferDestroy().
  */
 int ShClTransferCreate(PSHCLTRANSFER *ppTransfer)
@@ -1206,5 +1204,5 @@
     LogFlowFuncEnter();
 
-    int rc = sharedClipboardTransferThreadDestroy(pTransfer, 30 * 1000 /* Timeout in ms */);
+    int rc = shClTransferThreadDestroy(pTransfer, 30 * 1000 /* Timeout in ms */);
     if (RT_FAILURE(rc))
         return rc;
@@ -2353,5 +2351,5 @@
                     VERR_WRONG_ORDER);
 
-    int rc = sharedClipboardTransferThreadCreate(pTransfer, pfnThreadFunc, pvUser);
+    int rc = shClTransferThreadCreate(pTransfer, pfnThreadFunc, pvUser);
 
     LogFlowFuncLeaveRC(rc);
@@ -2435,5 +2433,5 @@
  * @param   pvUser              Pointer to user-provided data.
  */
-static int sharedClipboardTransferThreadCreate(PSHCLTRANSFER pTransfer, PFNRTTHREAD pfnThreadFunc, void *pvUser)
+static int shClTransferThreadCreate(PSHCLTRANSFER pTransfer, PFNRTTHREAD pfnThreadFunc, void *pvUser)
 
 {
@@ -2475,5 +2473,5 @@
  * @param   uTimeoutMs          Timeout (in ms) to wait for thread creation.
  */
-static int sharedClipboardTransferThreadDestroy(PSHCLTRANSFER pTransfer, RTMSINTERVAL uTimeoutMs)
+static int shClTransferThreadDestroy(PSHCLTRANSFER pTransfer, RTMSINTERVAL uTimeoutMs)
 {
     AssertPtrReturn(pTransfer, VERR_INVALID_POINTER);
@@ -2576,5 +2574,5 @@
  * @param   uID                 ID of the transfer to return.
  */
-static PSHCLTRANSFER sharedClipboardTransferCtxGetTransferInternal(PSHCLTRANSFERCTX pTransferCtx, uint32_t uID)
+static PSHCLTRANSFER shClTransferCtxGetTransferInternal(PSHCLTRANSFERCTX pTransferCtx, uint32_t uID)
 {
     PSHCLTRANSFER pTransfer;
@@ -2597,5 +2595,5 @@
 PSHCLTRANSFER ShClTransferCtxGetTransfer(PSHCLTRANSFERCTX pTransferCtx, uint32_t uID)
 {
-    return sharedClipboardTransferCtxGetTransferInternal(pTransferCtx, uID);
+    return shClTransferCtxGetTransferInternal(pTransferCtx, uID);
 }
 
@@ -2723,5 +2721,5 @@
     LogFlowFunc(("idTransfer=%RU32\n", idTransfer));
 
-    PSHCLTRANSFER pTransfer = sharedClipboardTransferCtxGetTransferInternal(pTransferCtx, idTransfer);
+    PSHCLTRANSFER pTransfer = shClTransferCtxGetTransferInternal(pTransferCtx, idTransfer);
     if (pTransfer)
     {
@@ -2848,6 +2846,6 @@
  * @sa Initially taken from vbsfConvertFileOpenFlags().
  */
-static int sharedClipboardConvertFileCreateFlags(bool fWritable, unsigned fShClFlags, RTFMODE fMode,
-                                                 SHCLOBJHANDLE handleInitial, uint64_t *pfOpen)
+static int shClConvertFileCreateFlags(bool fWritable, unsigned fShClFlags, RTFMODE fMode,
+                                      SHCLOBJHANDLE handleInitial, uint64_t *pfOpen)
 {
     uint64_t fOpen = 0;