Index: trunk/src/VBox/HostServices/SharedFolders/vbsf.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedFolders/vbsf.cpp	(revision 78947)
+++ trunk/src/VBox/HostServices/SharedFolders/vbsf.cpp	(revision 81369)
@@ -326,5 +326,5 @@
  * @param  fMode      file attributes
  * @param  handleInitial initial handle
- * @retval pfOpen     iprt create flags
+ * @param  pfOpen     Where to return iprt create flags
  */
 static int vbsfConvertFileOpenFlags(bool fWritable, unsigned fShflFlags, RTFMODE fMode, SHFLHANDLE handleInitial, uint64_t *pfOpen)
@@ -556,15 +556,17 @@
  *
  * @returns IPRT status code
- * @param  pClient               Data structure describing the client accessing the shared folder
- * @param  root                  The index of the shared folder in the table of mappings.
- * @param  pszPath               Path to the file or folder on the host.
- * @param  pParms @a CreateFlags Creation or open parameters, see include/VBox/shflsvc.h
- * @param  pParms @a Info        When a new file is created this specifies the initial parameters.
- *                               When a file is created or overwritten, it also specifies the
- *                               initial size.
- * @retval pParms @a Resulte     Shared folder status code, see include/VBox/shflsvc.h
- * @retval pParms @a Handle      On success the (shared folder) handle of the file opened or
- *                               created
- * @retval pParms @a Info        On success the parameters of the file opened or created
+ * @param  pClient  Data structure describing the client accessing the shared folder
+ * @param  root     The index of the shared folder in the table of mappings.
+ * @param  pszPath  Path to the file or folder on the host.
+ * @param  pParms   Input:
+ *                    - @a CreateFlags: Creation or open parameters, see include/VBox/shflsvc.h
+ *                    - @a Info:        When a new file is created this specifies the initial parameters.
+ *                                      When a file is created or overwritten, it also specifies the
+ *                                      initial size.
+ *                  Output:
+ *                    - @a Result:      Shared folder status code, see include/VBox/shflsvc.h
+ *                    - @a Handle:      On success the (shared folder) handle of the file opened or
+ *                                      created
+ *                    - @a Info:        On success the parameters of the file opened or created
  */
 static int vbsfOpenFile(SHFLCLIENTDATA *pClient, SHFLROOT root, char *pszPath, SHFLCREATEPARMS *pParms)
@@ -764,12 +766,15 @@
  *
  * @returns IPRT status code
- * @param  pClient               Data structure describing the client accessing the shared folder
- * @param  root                  The index of the shared folder in the table of mappings.
- * @param  pszPath               Path to the file or folder on the host.
- * @param  pParms @a CreateFlags Creation or open parameters, see include/VBox/shflsvc.h
- * @retval pParms @a Result      Shared folder status code, see include/VBox/shflsvc.h
- * @retval pParms @a Handle      On success the (shared folder) handle of the folder opened or
- *                               created
- * @retval pParms @a Info        On success the parameters of the folder opened or created
+ * @param  pClient  Data structure describing the client accessing the shared
+ *                  folder
+ * @param  root     The index of the shared folder in the table of mappings.
+ * @param  pszPath  Path to the file or folder on the host.
+ * @param  pParms   Input: @a CreateFlags Creation or open parameters, see
+ *                  include/VBox/shflsvc.h
+ *                  Output:
+ *                    - @a Result: Shared folder status code, see include/VBox/shflsvc.h
+ *                    - @a Handle: On success the (shared folder) handle of the folder opened or
+ *                                 created
+ *                    - @a Info:   On success the parameters of the folder opened or created
  *
  * @note folders are created with fMode = 0777
@@ -949,6 +954,8 @@
  * @param   pClient    client data
  * @param   pszPath    The path of the file to be looked up
- * @retval  pParms->Result Status of the operation (success or error)
- * @retval  pParms->Info   On success, information returned about the file
+ * @param   pParms     Output:
+ *                      - @a Result: Status of the operation (success or error)
+ *                      - @a Info:   On success, information returned about the
+ *                                   file
  */
 static int vbsfLookupFile(SHFLCLIENTDATA *pClient, char *pszPath, SHFLCREATEPARMS *pParms)
@@ -1012,17 +1019,19 @@
  *
  * @returns IPRT status code, but see note below
- * @param   pClient        Data structure describing the client accessing the shared
- *                         folder
- * @param   root           The index of the shared folder in the table of mappings.
- *                         The host path of the shared folder is found using this.
- * @param   pPath          The path of the file or folder relative to the host path
- *                         indexed by root.
- * @param   cbPath         Presumably the length of the path in pPath.  Actually
- *                         ignored, as pPath contains a length parameter.
- * @param   pParms @a Info If a new file is created or an old one overwritten, set
- *                         these attributes
- * @retval  pParms @a Result Shared folder result code, see include/VBox/shflsvc.h
- * @retval  pParms @a Handle Shared folder handle to the newly opened file
- * @retval  pParms @a Info Attributes of the file or folder opened
+ * @param   pClient     Data structure describing the client accessing the
+ *                      shared folder
+ * @param   root        The index of the shared folder in the table of mappings.
+ *                      The host path of the shared folder is found using this.
+ * @param   pPath       The path of the file or folder relative to the host path
+ *                      indexed by root.
+ * @param   cbPath      Presumably the length of the path in pPath. Actually
+ *                      ignored, as pPath contains a length parameter.
+ * @param   pParms      Input: If a new file is created or an old one
+ *                      overwritten, set the @a Info attribute.
+ *
+ *                      Output:
+ *                        - @a Result Shared folder result code, see include/VBox/shflsvc.h
+ *                        - @a Handle Shared folder handle to the newly opened file
+ *                        - @a Info Attributes of the file or folder opened
  *
  * @note This function returns success if a "non-exceptional" error occurred,
Index: trunk/src/VBox/HostServices/SharedFolders/vbsf.h
===================================================================
--- trunk/src/VBox/HostServices/SharedFolders/vbsf.h	(revision 78947)
+++ trunk/src/VBox/HostServices/SharedFolders/vbsf.h	(revision 81369)
@@ -25,7 +25,7 @@
 #include <VBox/shflsvc.h>
 
-int vbsfCreate (SHFLCLIENTDATA *pClient, SHFLROOT root, SHFLSTRING *pPath, uint32_t cbPath, SHFLCREATEPARMS *pParms);
+int vbsfCreate(SHFLCLIENTDATA *pClient, SHFLROOT root, SHFLSTRING *pPath, uint32_t cbPath, SHFLCREATEPARMS *pParms);
 
-int vbsfClose (SHFLCLIENTDATA *pClient, SHFLROOT root, SHFLHANDLE Handle);
+int vbsfClose(SHFLCLIENTDATA *pClient, SHFLROOT root, SHFLHANDLE Handle);
 
 int vbsfRead(SHFLCLIENTDATA *pClient, SHFLROOT root, SHFLHANDLE Handle, uint64_t offset, uint32_t *pcbBuffer, uint8_t *pBuffer);
Index: trunk/src/VBox/HostServices/SharedFolders/vbsfpathabs.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedFolders/vbsfpathabs.cpp	(revision 78947)
+++ trunk/src/VBox/HostServices/SharedFolders/vbsfpathabs.cpp	(revision 81369)
@@ -98,5 +98,5 @@
 #if defined(RT_OS_WINDOWS)
     /** @todo This code is not needed in 6.0 and later as IPRT translates paths
-     *        to \\.\ format if they're too long.  */
+     *        to //./ (inverted slashes for doxygen) format if they're too long.  */
     const char *pszPathStart = pszRoot? pszRoot: pszPath;
 