Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 81404)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 81405)
@@ -144,11 +144,4 @@
 };
 
-struct UsageCode
-{
-    LONG usageId;
-    LONG usagePage;
-    bool fRelease;
-};
-
 
 /*********************************************************************************************************************************
@@ -196,5 +189,4 @@
 
     void setLockKey(int iKeyPosition, UISoftKeyboardKey *pKey);
-    UISoftKeyboardKey *lockKey(int iKeyPosition) const;
     void updateLockKeyStates(bool fCapsLockState, bool fNumLockState, bool fScrollLockState);
     void reset();
@@ -402,5 +394,4 @@
 
     void addScanCodePrefix(LONG scanCode);
-    const QVector<LONG> &scanCodePrefix() const;
 
     void setUsageId(LONG usageId);
@@ -512,6 +503,4 @@
     bool isFromResources() const;
 
-    void updateUIKeyCaptions(int iKeyPosition, UIKeyCaptions &newCaptions);
-
     void setEditable(bool fEditable);
     bool editable() const;
@@ -520,7 +509,6 @@
     const QUuid &physicalLayoutUuid() const;
 
-    void setKeyCapMap(const QMap<int, UIKeyCaptions> &keyCaptionsMap);
     void addOrUpdateUIKeyCaptions(int iKeyPosition, const UIKeyCaptions &keyCaptions);
-    UIKeyCaptions keyCaptions(int iKeyPosition);
+    UIKeyCaptions keyCaptions(int iKeyPosition) const;
 
     bool operator==(const UISoftKeyboardLayout &otherLayout);
@@ -670,8 +658,4 @@
     virtual void mouseMoveEvent(QMouseEvent *pEvent) /* override */;
     virtual void retranslateUi() /* override */;
-
-private slots:
-
-    void sltPhysicalLayoutForLayoutChanged(int iIndex);
 
 private:
@@ -923,9 +907,4 @@
 {
     m_lockKeys[iKeyPosition] = pKey;
-}
-
-UISoftKeyboardKey *UISoftKeyboardPhysicalLayout::lockKey(int iKeyPosition) const
-{
-    return m_lockKeys.value(iKeyPosition, 0);
 }
 
@@ -1180,5 +1159,4 @@
     connect(m_pLayoutNativeNameEdit, &QLineEdit::textChanged, this, &UIKeyboardLayoutEditor::sltLayoutNativeNameChanged);
 
-
     m_pLayoutNameLabel = new QLabel;
     m_pLayoutNameEdit = new QLineEdit;
@@ -1593,9 +1571,4 @@
 {
     m_scanCodePrefix << scanCodePrefix;
-}
-
-const QVector<LONG> &UISoftKeyboardKey::scanCodePrefix() const
-{
-    return m_scanCodePrefix;
 }
 
@@ -1796,11 +1769,4 @@
 }
 
-void UISoftKeyboardLayout::updateUIKeyCaptions(int iKeyPosition, UIKeyCaptions &newCaptions)
-{
-    if (!m_keyCaptionsMap.contains(iKeyPosition))
-        return;
-    m_keyCaptionsMap[iKeyPosition] = newCaptions;
-}
-
 QString UISoftKeyboardLayout::nameString() const
 {
@@ -1875,9 +1841,4 @@
 }
 
-void UISoftKeyboardLayout::setKeyCapMap(const QMap<int, UIKeyCaptions> &keyCaptionsMap)
-{
-    m_keyCaptionsMap = keyCaptionsMap;
-}
-
 void UISoftKeyboardLayout::addOrUpdateUIKeyCaptions(int iKeyPosition, const UIKeyCaptions &keyCaptions)
 {
@@ -1889,5 +1850,5 @@
 }
 
-UIKeyCaptions UISoftKeyboardLayout::keyCaptions(int iKeyPosition)
+UIKeyCaptions UISoftKeyboardLayout::keyCaptions(int iKeyPosition) const
 {
     return m_keyCaptionsMap[iKeyPosition];
@@ -2644,17 +2605,4 @@
 }
 
-void UISoftKeyboardWidget::sltPhysicalLayoutForLayoutChanged(int iIndex)
-{
-    if (!m_pCurrentKeyboardLayout)
-        return;
-    if (iIndex < 0 || iIndex >= m_physicalLayouts.size())
-        return;
-
-    if (m_pCurrentKeyboardLayout->physicalLayoutUuid() == m_physicalLayouts[iIndex].uid())
-        return;
-    m_pCurrentKeyboardLayout->setPhysicalLayoutUuid(m_physicalLayouts[iIndex].uid());
-    update();
-}
-
 void UISoftKeyboardWidget::setNewMinimumSize(const QSize &size)
 {
@@ -3215,12 +3163,9 @@
     int iDefaultHeight = attributes.value("defaultHeight").toInt();
     QVector<UISoftKeyboardRow> &rows = physicalLayout.rows();
-    int iRowCount = 0;
+
     while (m_xmlReader.readNextStartElement())
     {
         if (m_xmlReader.name() == "row")
-        {
             parseRow(iDefaultWidth, iDefaultHeight, rows);
-            ++iRowCount;
-        }
         else if (m_xmlReader.name() == "name")
             physicalLayout.setName(m_xmlReader.readElementText());
@@ -3821,10 +3766,4 @@
             m_pKeyboardWidget->parentDialogDeactivated();
     }
-    else if (pEvent->type() == QEvent::WindowDeactivate)
-    {
-        if (m_pKeyboardWidget)
-            m_pKeyboardWidget->parentDialogDeactivated();
-    }
-
     return QMainWindowWithRestorableGeometryAndRetranslateUi::event(pEvent);
 }