Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 81508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 81510)
@@ -176,5 +176,4 @@
 void UIRuntimeInfoWidget::retranslateUi()
 {
-
     m_strTableTitle = QApplication::translate("UIVMInformationDialog", "Runtime Attributes");
     m_strScreenResolutionLabel = QApplication::translate("UIVMInformationDialog", "Screen Resolution");
@@ -217,6 +216,6 @@
         iNewRow = iRow;
     insertRow(iNewRow);
-    setItem(iNewRow, 0, new QTableWidgetItem(strLabel, enmInfoRow));
-    setItem(iNewRow, 1, new QTableWidgetItem(strInfo, enmInfoRow));
+    setItem(iNewRow, 1, new QTableWidgetItem(strLabel, enmInfoRow));
+    setItem(iNewRow, 2, new QTableWidgetItem(strInfo, enmInfoRow));
     int iMargin = 0.2 * qApp->style()->pixelMetric(QStyle::PM_LayoutTopMargin);
     setRowHeight(iNewRow, 2 * iMargin + m_iFontHeight);
@@ -274,6 +273,6 @@
     {
         QString strLabel = uGuestScreens > 1 ?
-            QString("%1 %2:").arg(m_strScreenResolutionLabel).arg(QString::number(iScreen)) :
-            QString("%1:").arg(m_strScreenResolutionLabel);
+            QString("%1 %2").arg(m_strScreenResolutionLabel).arg(QString::number(iScreen)) :
+            QString("%1").arg(m_strScreenResolutionLabel);
         /* Insert the screen resolution row at the top of the table. Row 0 is the title row: */
         insertInfoRow(InfoRow_Resolution, strLabel, m_screenResolutions[iScreen], iScreen + 1);
@@ -297,5 +296,5 @@
                 uUpDays, uUpHours, uUpMins, uUpSecs);
     QString strUptime = QString(szUptime);
-    updateInfoRow(InfoRow_Uptime, QString("%1:").arg(m_strUptimeLabel), strUptime);
+    updateInfoRow(InfoRow_Uptime, QString("%1").arg(m_strUptimeLabel), strUptime);
 }
 
@@ -303,5 +302,6 @@
 {
     /* Add the title row always as 0th row: */
-    QTableWidgetItem *pTitleItem = new QTableWidgetItem(UIIconPool::iconSet(":/state_running_16px.png"), m_strTableTitle, InfoRow_Title);
+    QTableWidgetItem *pTitleIcon = new QTableWidgetItem(UIIconPool::iconSet(":/state_running_16px.png"), "", InfoRow_Title);
+    QTableWidgetItem *pTitleItem = new QTableWidgetItem(m_strTableTitle, InfoRow_Title);
     QFont titleFont(font());
     titleFont.setBold(true);
@@ -309,5 +309,7 @@
     if (rowCount() < 1)
         insertRow(0);
-    setItem(0, 0, pTitleItem);
+    setItem(0, 0, pTitleIcon);
+    setItem(0, 1, pTitleItem);
+    resizeColumnToContents(0);
 }
 
@@ -319,5 +321,5 @@
     else
         strOSType = uiCommon().vmGuestOSTypeDescription(strOSType);
-   updateInfoRow(InfoRow_GuestOSType, QString("%1:").arg(m_strGuestOSTypeLabel), strOSType);
+   updateInfoRow(InfoRow_GuestOSType, QString("%1").arg(m_strGuestOSTypeLabel), strOSType);
 }
 
@@ -356,8 +358,8 @@
     QString strParavirtProvider = gpConverter->toString(m_machine.GetEffectiveParavirtProvider());
 
-    updateInfoRow(InfoRow_ExecutionEngine, QString("%1:").arg(m_strExcutionEngineLabel), strExecutionEngine);
-    updateInfoRow(InfoRow_NestedPaging, QString("%1:").arg(m_strNestedPagingLabel), strNestedPaging);
-    updateInfoRow(InfoRow_UnrestrictedExecution, QString("%1:").arg(m_strUnrestrictedExecutionLabel), strUnrestrictedExecution);
-    updateInfoRow(InfoRow_Paravirtualization, QString("%1:").arg(m_strParavirtualizationLabel), strParavirtProvider);
+    updateInfoRow(InfoRow_ExecutionEngine, QString("%1").arg(m_strExcutionEngineLabel), strExecutionEngine);
+    updateInfoRow(InfoRow_NestedPaging, QString("%1").arg(m_strNestedPagingLabel), strNestedPaging);
+    updateInfoRow(InfoRow_UnrestrictedExecution, QString("%1").arg(m_strUnrestrictedExecutionLabel), strUnrestrictedExecution);
+    updateInfoRow(InfoRow_Paravirtualization, QString("%1").arg(m_strParavirtualizationLabel), strParavirtProvider);
 
 }
@@ -375,5 +377,5 @@
             strGAVersion += QString(" r%1").arg(uRevision);
     }
-   updateInfoRow(InfoRow_GuestAdditions, QString("%1:").arg(m_strGuestAdditionsLabel), strGAVersion);
+   updateInfoRow(InfoRow_GuestAdditions, QString("%1").arg(m_strGuestAdditionsLabel), strGAVersion);
 }
 
@@ -383,5 +385,5 @@
     QString strVRDEInfo = (iVRDEPort == 0 || iVRDEPort == -1) ?
         m_strNotAvailable : QString("%1").arg(iVRDEPort);
-   updateInfoRow(InfoRow_RemoteDesktop, QString("%1:").arg(m_strRemoteDesktopLabel), strVRDEInfo);
+   updateInfoRow(InfoRow_RemoteDesktop, QString("%1").arg(m_strRemoteDesktopLabel), strVRDEInfo);
 }
 
@@ -389,8 +391,8 @@
 {
     if (enmMode == KClipboardMode_Max)
-        updateInfoRow(InfoRow_ClipboardMode, QString("%1:").arg(m_strClipboardModeLabel),
+        updateInfoRow(InfoRow_ClipboardMode, QString("%1").arg(m_strClipboardModeLabel),
                       gpConverter->toString(m_machine.GetClipboardMode()));
     else
-        updateInfoRow(InfoRow_ClipboardMode, QString("%1:").arg(m_strClipboardModeLabel),
+        updateInfoRow(InfoRow_ClipboardMode, QString("%1").arg(m_strClipboardModeLabel),
                       gpConverter->toString(enmMode));
 }
@@ -399,8 +401,8 @@
 {
     if (enmMode == KDnDMode_Max)
-        updateInfoRow(InfoRow_DnDMode, QString("%1:").arg(m_strDragAndDropLabel),
+        updateInfoRow(InfoRow_DnDMode, QString("%1").arg(m_strDragAndDropLabel),
                   gpConverter->toString(m_machine.GetDnDMode()));
     else
-        updateInfoRow(InfoRow_DnDMode, QString("%1:").arg(m_strDragAndDropLabel),
+        updateInfoRow(InfoRow_DnDMode, QString("%1").arg(m_strDragAndDropLabel),
                       gpConverter->toString(enmMode));
 }
@@ -427,5 +429,5 @@
     clear();
     setRowCount(0);
-    setColumnCount(2);
+    setColumnCount(3);
     updateTitleRow();
     updateScreenInfo();